<?php
if(!function_exists('sql_table')) {
	function sql_table($name) {return 'nucleus_'.$name;}
}
class NP_SC extends NucleusPlugin {
	function getName() {return "SC";}
	function getAuthor() {return "jun";}
	function getURL() {return "http://nucleus.mz-style.com/";}
	function getVersion() {return "0.12";}
	function getDescription() {return "Schedule and Calendar plugin.";}
	function supportsFeature($what) {
		switch($what) {
		case 'SqlTablePrefix':
			return 1;
		default:
			return 0;
		}
	}
	function getEventList() {return array('AddItemFormExtras', 'EditItemFormExtras', 'PostAddItem', 'PreUpdateItem', 'PostDeleteItem');}
	function install() {
		sql_query('CREATE TABLE IF NOT EXISTS '.sql_table('plugin_sc').' (
sitemid int(11) NOT NULL, 
stime datetime, 
smemid int(11), 
PRIMARY KEY (sitemid)
)');
		$this->createOption('sc_date', _NP_SC_OP_1, 'text', '');
		$this->createOption('sc_uninstall', _NP_SC_OP_2, 'yesno', 'no');
		$this->createOption('sc_date_f1', _NP_SC_OP_3, 'text', 'Y-m-d H:i');
		$this->createOption('sc_date_f2', _NP_SC_OP_4, 'text', 'H:i');
		$this->createOption('sc_date_f3', _NP_SC_OP_5, 'text', 'm/d');
		$this->createOption('sc_temple_all', _NP_SC_OP_6, 'text', _NP_SC_FORM11);
		$this->createOption('sc_temple_mem', _NP_SC_OP_7, 'text', _NP_SC_FORM12);
		$this->createOption('sc_title', _NP_SC_OP_8, 'text', '');
	}
	function uninstall() {
		if($this->getOption('sc_uninstall') == 'yes') {
			mysql_query("DROP table ".sql_table('plugin_sc'));
		}
		$this->deleteOption('sc_date');
		$this->deleteOption('sc_uninstall');
		$this->deleteOption('sc_date_f1');
		$this->deleteOption('sc_date_f2');
		$this->deleteOption('sc_date_f3');
		$this->deleteOption('sc_temple_all');
		$this->deleteOption('sc_temple_mem');
		$this->deleteOption('sc_title');
	}
	function init() {
		$language = ereg_replace( '[\\|/]', '', getLanguageName());
		if(file_exists($this->getDirectory().$language.'.php')) {
			include_once($this->getDirectory().$language.'.php');
		}else {
			include_once($this->getDirectory().'english.php');
		}
	}
	function getTableList() {
		return array(sql_table('plugin_sc'));
	}
	function event_AddItemFormExtras($data) {
		$this->ItemForm(0);
	}
	function event_EditItemFormExtras($data) {
		global $itemid;
		$itemid = intval($itemid);
		$this->ItemForm($itemid);
	}
	function ItemForm($id) {
		global $member;
		if(!$id && $_GET['sche']) $sche = date("Y-m-d H:i:s", strtotime(addslashes($_GET['sche'])));
		$memid = $member->getID();
		if($id) $j1 = quickQuery('SELECT stime as result FROM '.sql_table('plugin_sc')." WHERE sitemid = ".$id);
		if($j1 || $sche) {
			$c1 = ' checked="checked"';
		}else {
			$c2 = ' checked="checked"';
		}
		$sdate = ($j1) ? $j1 : date("Y-m-d H:i:s", time()+($this->getOption('sc_date')*3600));
		if(!$id && $_GET['sche']) $sdate = $sche;
		if($id) $j2 = quickQuery('SELECT smemid as result FROM '.sql_table('plugin_sc')." WHERE sitemid = ".$id);
		if(!$j1 || $j2 || !$id) {
			$c3 = ' checked="checked"';
		}else {
			$c4 = ' checked="checked"';
		}
		echo '<h3>'._NP_SC_FORM0.'</h3>
<fieldset>
<label for="act_yes"><input name="plugin_sc_time" value="act_yes"'.$c1.' id="act_yes" type="radio">'._NP_SC_FORM1.'</label>
<div class="indent">
'._NP_SC_FORM2.'
<input id="inputyear" name="plugin_sc_year" size="4" maxlength="4" value="'.date("Y", strtotime($sdate)).'">'._NP_SC_FORM3.'
<input id="inputmonth" name="plugin_sc_month" size="2" maxlength="2" value="'.date("m", strtotime($sdate)).'">'._NP_SC_FORM4.'
<input id="inputday" name="plugin_sc_day" size="2" maxlength="2" value="'.date("d", strtotime($sdate)).'">'._NP_SC_FORM5.'
<input id="inputhour" name="plugin_sc_hour" size="2" maxlength="2" value="'.date("H", strtotime($sdate)).'">'._NP_SC_FORM6.'
<input id="inputminutes" name="plugin_sc_minutes" size="2" maxlength="2" value="'.date("i", strtotime($sdate)).'">'._NP_SC_FORM7.'
<br />
'._NP_SC_FORM8.'(yyyy)'._NP_SC_FORM3.'(mm)'._NP_SC_FORM4.'(dd)'._NP_SC_FORM5.' (hh)'._NP_SC_FORM6.'(mm)'._NP_SC_FORM7.'
</div>
<label for="act_no"><input name="plugin_sc_time" value="act_no"'.$c2.' id="act_no" type="radio">'._NP_SC_FORM9.'</label>
</fieldset>
<fieldset>
<legend>'._NP_SC_FORM10.'</legend>
<label for="mem"><input name="plugin_sc_mem" value="'.$memid.'"'.$c3.' id="mem" type="radio">'._NP_SC_FORM11.'</label>
<label for="0"><input name="plugin_sc_mem" value="0"'.$c4.' id="0" type="radio">'._NP_SC_FORM12.'</label> 
</fieldset>
';
	}
	function event_PostAddItem($data) {
		$itemid = intval($data['itemid']);
		$stime = requestVar('plugin_sc_time');
		if($stime == 'act_yes') {
			$smemid = requestVar('plugin_sc_mem');
			$smemid = intval($smemid);
			$time = requestVar('plugin_sc_year').'-'.requestVar('plugin_sc_month').'-'.requestVar('plugin_sc_day').' '.requestVar('plugin_sc_hour').':'.requestVar('plugin_sc_minutes').':00';
			$time = addslashes($time);
			sql_query('INSERT INTO '.sql_table('plugin_sc')." (sitemid, stime, smemid) VALUES ('$itemid', '$time', '$smemid')");
		}
		return;
	}
	function event_PreUpdateItem($data) {
		global $itemid;
		$itemid = intval($itemid);
		$stime = requestVar('plugin_sc_time');
		$j1 = quickQuery('SELECT stime as result FROM '.sql_table('plugin_sc')." WHERE sitemid = ".$itemid);
		if($stime == 'act_yes') {
			$smemid = requestVar('plugin_sc_mem');
			$smemid = intval($smemid);
			$time = requestVar('plugin_sc_year').'-'.requestVar('plugin_sc_month').'-'.requestVar('plugin_sc_day').' '.requestVar('plugin_sc_hour').':'.requestVar('plugin_sc_minutes').':00';
			$time = addslashes($time);
		}
		if($j1) {
			if($stime == 'act_yes') {
				sql_query("UPDATE ".sql_table('plugin_sc')." SET stime = '".$time."', smemid = '".$smemid."' WHERE sitemid = '".$itemid."'");
			}else {
				sql_query('DELETE FROM '.sql_table('plugin_sc')." WHERE sitemid = ".$itemid);
			}
		}elseif($stime == 'act_yes') {
			sql_query('INSERT INTO '.sql_table('plugin_sc')." (sitemid, stime, smemid) VALUES ('$itemid', '$time', '$smemid')");
		}
		return;
	}
	function event_PostDeleteItem($data) {
		global $itemid;
		$itemid = intval($itemid);
		sql_query('DELETE FROM '.sql_table('plugin_sc')." WHERE sitemid = ".$itemid);
		return;
	}
	function doTemplateCommentsVar(&$item, &$comment, $mode = '') {
		$this->doTemplateVar(&$item, $mode);
	}
	function doTemplateVar(&$item, $op = '', $mem = '') {
		$itemid = intval($item->itemid);
		if(!$op) $op = 1;
		$q1 = sql_query('SELECT UNIX_TIMESTAMP(stime) as stime, smemid FROM '.sql_table('item').' left join '.sql_table('plugin_sc').' on sitemid = inumber WHERE inumber = '.$itemid);
		while($row = mysql_fetch_assoc($q1)) {
			$mem_f = ($row['smemid']) ? 'mem' : 'all';
			if($row['stime']) $view = (!$mem) ? date($this->getOption('sc_date_f'.$op), $row['stime']) : '<span class="sc_'.$mem_f.'">'.$this->getOption("sc_temple_".$mem_f).'</span>';
		}
		if(substr($view, -5) == '00:00') $view = substr($view, 0, -5);
		echo $view;
	}
	function doSkinVar($skinType, $template = '', $nums = '', $sblog = '', $ist = '', $scat = '') {
		global $blogid, $catid, $archive, $blog, $itemid, $member;
		$blogid = intval($blogid);
		$catid = intval($catid);
		$itemid = intval($itemid);
		$temple = explode('/', $template, 2);
		$num = explode('/', $nums, 2);
		$is = explode('/', $ist, 2);
		$ttime = ($is[0] == 1 || $is[0] == 3) ? 'itime' : 'stime';
		$order = ($is[0] == 2 || $is[0] == 3) ? 'DESC' : 'ASC';
// LoggedIn Member
		if($member->isLoggedIn() && $ttime == 'stime') $where .= ' and (smemid = '.$member->getID().' || smemid = 0)';
// Category
		$scats = explode('/', $scat, 2);
		switch($scats[0]) {
		case '':
			break;
		case 'all':
			break;
		case 'no':
			$scat = explode('/', $scats[1]);
			foreach($scat as $scats) $where .= ' and icat != '.$scats;
			break;
		default:
			$scat = str_replace('/', ', ', $scat);
			$where .= ' and icat in ('.$scat.')';
		}
// Blog
		$sblogs = explode('/', $sblog, 2);
		switch($sblogs[0]) {
		case '':
			$where .= ' and iblog = '.$blogid;
			if(!$scats[0] && $catid) $where .= ' and icat = '.$catid;
			break;
		case 'all':
			break;
		case 'no':
			$sblog = explode('/', $sblogs[1]);
			foreach($sblog as $sblogs) $where .= ' and iblog != '.$sblogs;
			break;
		default:
			$sblog = str_replace('/', ', ', $sblog);
			$where .= ' and iblog in ('.$sblog.')';
		}
// Archive
		switch(TRUE) {
		case($archive) :
			sscanf($archive, '%d-%d-%d', $y, $m, $d);
			$m = substr($m ,0, 2);
			$d = substr($d ,0, 2);
			break;
		case($itemid) :
			$itime = quickQuery('SELECT '.$ttime.' as result FROM '.sql_table('item').' left join '.sql_table('plugin_sc').' on sitemid = inumber WHERE inumber = '.$itemid.' ORDER BY null LIMIT 1');
			$y = date("Y", strtotime($itime));
			$m = date("m", strtotime($itime));
			break;
		default :
			$y = date("Y", time()+($this->getOption('sc_date')*3600));
			$m = date("m", time()+($this->getOption('sc_date')*3600));
		}
		switch(TRUE) {
		case($d && $temple[0] != 'list'):
			$time_s = mktime(0, 0, 0, $m, $d, $y);
			$time_e = mktime(0, 0, 0, $m, $d+1, $y);
			break;
		case($m):
			$time_s = mktime(0, 0, 0, $m, 1, $y);
			$time_e = mktime(0, 0, 0, $m+1, 1, $y);
		}
		if(($skinType == 'index' && !$catid && $temple[0] != 'list') || $is[1] == 2) $jd = 1;
		$time_ss = ($jd) ? mktime(0, 0, 0) : $time_s;
		if($jd) {
			$whe .= ' and '.$ttime.' >= '.mysqldate($time_ss);
		}elseif($is[1] != 1) {
			$whe .= ' and '.$ttime.' >= '.mysqldate($time_ss).' and '.$ttime.' < '.mysqldate($time_e);
		}
		switch($temple[0]) {
		case 'list' :
			$this->actList($temple[1], $ttime, $time_s, $where, $y, $m, $whe);
			break;
// Schedule Blog
		default :
			$limit = ($num[0]) ? $num[0] : 100;
			$query = 'SELECT inumber as itemid, iblog as blog, ibody as body, mname as author, mrealname as authorname, UNIX_TIMESTAMP(itime) as timestamp, itime, stime, imore as more, mnumber as authorid, cname as category, icat as catid, iclosed as closed, memail as authormail, murl as authorurl, ititle as title FROM '.sql_table('item').' left join '.sql_table('plugin_sc').' on sitemid = inumber , '.sql_table('member').', '.sql_table('category').' WHERE iauthor = mnumber and icat = catid and idraft = 0'.$where.$whe.' ORDER BY '.$ttime.' '.$order.' LIMIT '.$limit;
			switch(TRUE) {
			case($catid) :
				$cname = quickQuery('SELECT cname as result FROM '.sql_table('category').' WHERE catid = '.$catid);
				$arch = ($archive) ? $archive : $y.'-'.$m;
				$top = $arch.' : '.$cname;
				break;
			case($archive) :
				$top = $archive;
				break;
			case($skinType == 'index') :
				$top = date("Y-m-d").' : '._NP_SC_RECENT;
			}
			if($num[1] == 1) echo '<div class="sc_top">'.htmlspecialchars($top).'</div>';
			$blog->showUsingQuery($template, $query, 1, 1, 1);
		}
	}
	function actList($temple = '', $ttime = '', $time_s = '', $where = '', $y = '', $m = '', $whe = '') {
		global $blogid, $CONF, $member;
		$blogid = intval($blogid);
// Template
		switch($temple) {
		case 'div' :
			$e = array('div', 'div', 'span');
			break;
		case '' :
			$e = array('table', 'tr', 'td');
			break;
		default :
			$e = array($temple, 'li', 'span');
		}
// Array Merge
		$query = sql_query('SELECT DATE_FORMAT('.$ttime.',"%Y%m%d") as day, MIN(CONCAT('.$ttime.',"/",ititle)) as time, COUNT(inumber) as count FROM '.sql_table('item').' left join '.sql_table('plugin_sc').' on sitemid = inumber WHERE idraft = 0 '.$where.$whe.' GROUP BY day');
		while($row = mysql_fetch_assoc($query)) {
			$tt = explode('/', $row['time'], 2);
			$time = strtotime($tt[0]);
			$g0['a'.date("d", $time)] = date("w", $time).'^^^^'.date("H:i", $time).'^^^^'.$tt[1].'^^^^'.$row['count'];
		}
		$time_s1 = date("Y-m", $time_s);
		for($i=1; $i<=date("t", $time_s); $i++) {
			if($i<10) $i = '0'.$i;
			$g1['a'.$i] = date("w", strtotime($time_s1."-".$i));
		}
		$g2 = array_merge($g1, $g0);
// List
		foreach($g2 as $g10=>$g11) {
			$a = substr($g10, 1);
			$b = explode('^^^^', $g11, 4);
			if($member->isLoggedIn() && $ttime == 'stime' && ($member->isAdmin() || $member->isTeamMember($blogid))) $a00 = array('<a href="'.$CONF['AdminURL'].'bookmarklet.php?blogid='.$blogid.'&amp;sche='.$time_s1."-".$a.'" title="'._NP_SC_FORM1.'" target="_blank">', '</a>');
			if($b[1] == '00:00') $b[1] = '';
			$cc = ($b[3]>1) ? '<span class="sc_num">('.$b[3].')</span>' : '';
			$cd = ($b[3]>1) ? _NP_SC_ETC : '';
			$a01 = array('<a href="'.createArchiveLink($blogid, $time_s1."-".$a).'" title="'.substr($time_s1, -2, 2).'/'.$a.' '.$b[1].' '.$b[2].$cd.'">', '</a>');
			$tc = $this->getOption('sc_title');
			if($tc) $b[2] = (_CHARSET == 'EUC-JP') ? mb_strimwidth($b[2], 0, $tc, '..', euc) : mb_strimwidth($b[2], 0, $tc, '..', utf8);
			switch(TRUE) {
			case($b[2]) :
				$c = '<'.$e[2].' class="sc_sub">'.$a01[0].$b[2].$a01[1].$cc.'</'.$e[2].'>';
				break;
			case(!$temple) :
				$c = '<'.$e[2].' class="sc_sub"></'.$e[2].'>';
				break;
			default :
				$c = '';
			}
			$day0 = array(
0=>_NP_SC_DAY0, 
1=>_NP_SC_DAY1, 
2=>_NP_SC_DAY2, 
3=>_NP_SC_DAY3, 
4=>_NP_SC_DAY4, 
5=>_NP_SC_DAY5, 
6=>_NP_SC_DAY6
			);
			foreach($day0 as $d1=>$d2) if($d1 == $b[0]) $day_u = $d2;
			$ss = '';
			if($b[0] == 0) $ss = '_sun';
			if($b[0] == 6) $ss = '_sat';
			if(date("Y-m-d", strtotime($time_s1."-".$a)) == date("Y-m-d", time())) $ss = '_today';
			$text .= '<'.$e[1].' class="sc_body'.$ss.'">
<'.$e[2].' class="sc_sub">'.$a00[0].$a.$a00[1].'</'.$e[2].'>
<'.$e[2].' class="sc_sub">'.$day_u.'</'.$e[2].'>
'.$c.'
</'.$e[1].'>';
		}
// Navi
		switch($ttime) {
		case 'stime' :
			$p_month = date("Y-m", strtotime("-1 month", strtotime($time_s1."-01")));
			$n_month = date("Y-m", strtotime("+1 month", strtotime($time_s1."-01")));
			$p_m = '<a href="'.createArchiveLink($blogid, $p_month).'" title="'._NP_SC_PREV.'">&laquo;</a> ';
			$n_m = ' <a href="'.createArchiveLink($blogid, $n_month).'" title="'._NP_SC_NEXT.'">&raquo;</a>';
			for($i=$m; $i>=1; $i--) {
				if(strlen($i) == 1) $i = '0'.$i;
				$m1 = ($y+1).'-'.$i;
				$ta .= '<option value="'.$m1.'">'.$m1.'</option>';
			}
			for($i=12; $i>=1; $i--) {
				if($i<10) $i = '0'.$i;
				$m2 = $y.'-'.$i;
				$check = ($i == $m) ? ' selected="selected"' : '';
				$ta .= '<option value="'.$m2.'"'.$check.'>'.$m2.'</option>';
			}
			for($i=12; $i>=$m; $i--) {
				if($i<10) $i = '0'.$i;
				$m3 = ($y-1).'-'.$i;
				$ta .= '<option value="'.$m3.'">'.$m3.'</option>';
			}
			break;
		default :
			$q2 = sql_query('SELECT DATE_FORMAT(itime,"%Y-%m") as month, COUNT(inumber) as count FROM '.sql_table('item').' WHERE idraft = 0 '.$where.' GROUP BY month ORDER BY month DESC');
			if(strlen($m) == 1) $m = '0'.$m;
			while($row = mysql_fetch_assoc($q2)) {
				$check = ($row['month'] == $y.'-'.$m) ? ' selected="selected"' : '';
				$ta .= '<option value="'.$row['month'].'"'.$check.'>'.$row['month'].' ('.$row['count'].')</option>';
			}
		}
// Print
		echo '<div class="sc_title">
<form method="get" action="'.$CONF['IndexURL'].'" class="sc_form">
<div>'.$p_m.'
<input name="blogid" value="'.$blogid.'" type="hidden" />
<select name="archive" onchange="return form.submit()" class="sc_select" tabindex="1001" >'
.$ta.
'</select>
'.$n_m.'
<input value="GO" type="submit" class="sc_submit" tabindex="1002" accesskey="1" />
</div>
</form>
</div>
<'.$e[0].' class="sc_list">'
.$text.'
</'.$e[0].'>';
	}
}